=== src/XrdSut/CMakeLists.txt ===
target_sources(XrdUtils
  PRIVATE
    XrdSutAux.cc         XrdSutAux.hh
    XrdSutBuckList.cc    XrdSutBuckList.hh
    XrdSutBucket.cc      XrdSutBucket.hh
    XrdSutBuffer.cc      XrdSutBuffer.hh
    XrdSutCacheEntry.cc  XrdSutCacheEntry.hh
    XrdSutPFCache.cc     XrdSutPFCache.hh
    XrdSutPFEntry.cc     XrdSutPFEntry.hh
    XrdSutPFile.cc       XrdSutPFile.hh
    XrdSutRndm.cc        XrdSutRndm.hh
    XrdSutTrace.hh
)
