=== debian/changelog ===
xrootd (5.8.4-2) unstable; urgency=medium

  * Exclude the XRootD::posix::test test for some architectures

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 18 Jul 2025 17:39:37 +0200

xrootd (5.8.4-1) unstable; urgency=medium

  * Update to version 5.8.4

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 15 Jul 2025 09:23:49 +0200
